<?php

namespace Nest\Http;

use Nest\Exceptions\Services\Configuration\UndefinedServiceConfigurationException;

/**
 * HTTP Nest service.
 */
trait HttpService
{
	/**
	 * HTTP manager.
	 * @var Http
	 */
	private Http $http;

	/**
	 * @return void
	 * @throws UndefinedServiceConfigurationException
	 */
	protected function __nest__HttpService(): void
	{
		// Initialize HTTP manager.
		$this->http = new Http($this, $this->getServiceConfiguration(HttpConfiguration::class));
	}

	/**
	 * Get the HTTP manager.
	 * @return Http HTTP manager instance.
	 */
	public function http(): Http
	{
		return $this->http;
	}
}
