<?php

namespace Nest\Http\Router;

use Psr\Http\Message\ResponseInterface;

/**
 * A matched route result.
 */
readonly class RouteMatch
{
	/**
	 * @param Route $route Matched route.
	 * @param array<string, string> $params Matched URL parameters.
	 */
	public function __construct(public Route $route, public array $params)
	{}

	/**
	 * Call the matched route handler with parameters.
	 * @return ResponseInterface The retrieved response from route.
	 */
	public function __invoke(): ResponseInterface
	{
		return call_user_func_array($this->route->getHandler(), $this->params);
	}
}
